# Path to the tentris datastore to open.
# The option set on the commandline takes precendence over this value.
# If it is neither set here nor on the commandline "./tentris-data" is used.
datastore_path = "/upb/users/q/quannian/profiles/unix/cs/Tentris/QALD10/tentris-data"


[serve]
# The log level
# This can be used as an alternative to the TENTRIS_LOG environment variable
# or the --log-level command line argument.
# The precendence is as follows:
#   1. --log-level argument
#   2. this configuration option
#   3. the TENTRIS_LOG enviroment variable
#
# Options: "trace", "debug", "info", "warn" or "error"
log_level = "trace"


# The format of the log output
# Options: "default" or "json"
# log_output_format = "default"


# The address the server should bind to
# bind_address = "0.0.0.0:9080"


# The number of io threads used by the runtime to accept queries/write out results
# Default: number of CPUs in the executing system
# io_threads = 8


# The number of threads used by the runtime to evaluate queries
# Default: number of CPUs in the executing system
# query_eval_threads = 8


# The chunk size for serialization on the /stream route
# query_eval_stream_serialization_chunk_size = 65536


# Threshold of estimated garbage that needs to be reached in order for the garbage collector to run
# garbage_threshold = 1000000


# Require credentials to access the routes
# enable_auth = false


# Allow unauthorized access to /sparql, /stream and /ui
# allow_guests = false


# Starts the server in read-only mode (update endpoints are not available in this mode)
read_only = true


# Set the mode for the default graph.
# This is related to https://www.w3.org/TR/2013/REC-sparql11-service-description-20130321/#sd-uniondefaultgraph .
#
# Accepts "Standalone" or "Union"
# When "Standalone" is specified, the default graph is its own distinct graph.
# When "Union" is specified, the default graph is the union of all graphs.
# default_graph_mode = "Standalone"


# Limit the number of bytes accepted in request bodies on /sparql, /stream and /update
# Accepts "Unlimited" or an integer >= 1.
# limit_query_and_update_request_body_size = 8290304


# Limit the number of bytes accepted in request bodies on /graph-store-update
# Accepts "Unlimited" or an integer >= 1.
# limit_graph_store_update_request_body_size = "Unlimited"


# Limit the number of bytes the server is allowed to answer on /sparql
# Accepts "Unlimited" or an integer >= 1.
limit_sparql_response_body_size = "Unlimited"


# Timeout in milliseconds for answering requests
# Accepts "Unlimited" or an integer >= 1.
limit_request_duration_ms = "Unlimited"


# Limit the number of concurrent connection this server will accept (additional requests are rejected if the limit is reached)
# Accepts "Unlimited" or an integer >= 1.
# limit_concurrent_connections = "Unlimited"


# Limit the number of versions of the triplestore that are allowed to exist in parallel
#
# In write heavy workloads a lower limit results in lower RAM and disk space usage
# whereas a higher limit increases throughput.
#
# For further information see: https://en.wikipedia.org/wiki/Multiversion_concurrency_control
#
# Accepts "Unlimited" or an integer >= 2
# limit_versions = "Unlimited"


# Limit the number of snapshots kept during normal operation
#
# This is primarily useful on filesystems without reflinks (like ext4) because snapshots are a full copy of
# the datastore on these filesystems.
#
# Note: while performing a snapshot this limit will be briefly exceeded by one before the least-recent snapshot is pruned.
# Note: a value of zero indicates that no snapshots will ever be taken automatically. You can still take snapshots via CLI manually.
# Warning: not taking snapshots will render the database unrecoverable in the event of a crash if you have no other snapshots.
#
# Accepts "Unlimited" or an integer.
# limit_snapshots = 8


# Additional HTML to be placed in the header of the query UI web page
# ui_header_html = """
# <h3>serving</h3>
# <table style="font-weight: bold">
#     <tr>
#         <td><a href="http://example.org#g1" style="color: var(--tentris-red)">example graph 1</a></td>
#         <td>in graph</td>
#         <td style="color: var(--tentris-light-green)">&lthttp://example.org#g1&gt</td>
#     </tr>
#     <tr>
#         <td><a href="http://example.org#g2" style="color: var(--tentris-red)">example graph 2</a></td>
#         <td>in graph</td>
#         <td style="color: var(--tentris-light-green)">&lthttp://example.org#g2&gt</td>
#     </tr>
# </table>
# """